//Create a class for battery
package Battery
import Timer.SimulatedTimer

//JPF's Verify API
import gov.nasa.jpf.vm.Verify

public class Batteries {
	private int deviceNumbers
	private List batteries
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private String id = "batteryID0"
	private String label = "battery0"
	private String displayName = "battery0"
	private int battery = 50
	private int currentBattery = 50

		
	Batteries(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.batteries = []

		//def init = Verify.getIntFromList(30, 50, 70)
		//this.battery = init

		batteries.add(new Battery(id, label, displayName, this.battery))
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		if (eventDataMap["value"] != batteries[0].battery) {
			batteries[0].setValue(eventDataMap["value"])
			this.battery = batteries[0].battery
			this.currentBattery = batteries[0].battery
			sendEvent(eventDataMap)
		}
	}

	//Methods for closures
	def count(Closure Input) {
		batteries.count(Input)
	}
	def size() {
		batteries.size()
	}
	def each(Closure Input) {
		batteries.each(Input)
	}
	def find(Closure Input) {
		batteries.find(Input)
	}
	def collect(Closure Input) {
		batteries.collect(Input)
	}


	def currentValue(String deviceFeature) {
		batteries[0].currentValue(deviceFeature)//It is called if we have only one device
	}

	def getAt(int ix) {
		batteries[ix]
	}
}
