import os
readyToReturn = 0
ToReturn = ""
eventList = []
eventVarMap = {}
capabilityMap = {}
app1Capabilities = []
app2Capabilities = []
app1Subscribe = False
app2Subscribe = False

def GetToken(f):
	global readyToReturn
	global ToReturn
	Skip = ['\n', '\t', ' ']
	Special = ["(", "\"", ":", ",", "{", "}", ")", "/", "*"]
	S = ""
	if (readyToReturn):
		readyToReturn = 0
		return ToReturn
	ToReturn = ""
	c = f.read(1)
	while(True):
		if (c in Special):
			if (S != ""):
				readyToReturn = 1
				ToReturn = c
				return S
			else:
				return c
		elif (c in Skip):
			if (S != ""):
				return S	
			else:
				c = f.read(1)
				continue
		S += c
		c = f.read(1)
		if not c:
			return "EOF"

def ExtractFunctions(F, appName):
	global eventList
	global app1Subscribe
	global app2Subscribe
	Temp = GetToken(F)
	while (Temp != "EOF"):
		if (Temp == "def" or Temp == "private"):
			Temp = GetToken(F)
			if (Temp == "def" or Temp == "private"):
				Temp = GetToken(F)
			NameofFunc = Temp
			if (GetToken(F) == "("): #We have a function to create object for
				if (appName == "App1"):
					extractedFunctionsApp1.write("//Global Object for functions in subscribe method!\n")	
					extractedFunctionsApp1.write("def %s = this.&" % NameofFunc)
					extractedFunctionsApp1.write("%s\n" % NameofFunc)
				else:
					extractedFunctionsApp2.write("//Global Object for functions in subscribe method!\n")	
					extractedFunctionsApp2.write("def %s = this.&" % NameofFunc)
					extractedFunctionsApp2.write("%s\n" % NameofFunc)
		
		#Check input capability
		if (Temp == "input"):
			while Temp != "\"":
				Temp = GetToken(F)
			variable = GetToken(F)
			Temp = GetToken(F) #Get '"'
			Temp = GetToken(F) #Get ','
			while Temp != "\"":
				Temp = GetToken(F)
			capability = GetToken(F)
			capabilityMap[variable] = capability
		
		#Check subscribed events
		if (Temp == "subscribe"):
			if (appName == "App1"):
				app1Subscribe = True
			else:
				app2Subscribe = True
			Temp = GetToken(F)
			if (Temp == "("):
				Temp = GetToken(F)
			variable = Temp
			while (Temp != "\"" and Temp != "app" and Temp != "location"):
				Temp = GetToken(F)
			if Temp == "\"":
				Temp = GetToken(F)
			if Temp not in eventList:
				eventList.append(Temp)
				eventVarMap[Temp] = variable

		#Check and analyze capabilities for physical interaction
		AnalyzeCapabilities(Temp, appName, F)

		Temp = GetToken(F)
	
	#Warn if there is a potential for physical interaction
	AnalyzePhysicalInteraction(app1Capabilities, app2Capabilities)
	AnalyzePhysicalInteraction(app2Capabilities, app1Capabilities)


def AnalyzeCapabilities(Temp, appName, F):
			#Illuminance related
	if (Temp == "capability.switch" or
			Temp == "capability.switchLevel" or
			Temp == "capability.illuminanceMeasurement" or
			Temp == "capability.colorControl" or
			#Motion related
			Temp == "capability.motionSensor" or
			Temp == "capability.accelerationSensor" or
			#Water related
			Temp == "capability.valve" or
			Temp == "capability.waterSensor" or
			#Sound related
			Temp == "capability.musicPlayer" or
			Temp == "capability.alarm" or
			Temp == "capability.speechSynthesis" or
			Temp == "capability.soundSensor"):
		if (appName == "App1"):
			app1Capabilities.append(Temp)
		else:
			app2Capabilities.append(Temp)
	if (Temp == "capability"):
		Temp = GetToken(F) #Get '"'
		Temp = GetToken(F) #Get 'Music'
		Temp = Temp + GetToken(F) #Get 'Player'
		if (Temp == "MusicPlayer"):
			if (appName == "App1"):
				app1Capabilities.append("capability.musicPlayer")
			else:
				app2Capabilities.append("capability.musicPlayer")
			
def AnalyzePhysicalInteraction(app1Capab, app2Capab):
	#Light
	if ("capability.illuminanceMeasurement" in app1Capab) and ("capability.switch" in app2Capab or 
			"capability.switchLevel" in app2Capab or "capability.colorControl" in app2Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (light) detected between App1 and App2!\n")
	#Motion
	# TODO: Technically this is not entirely precise since we need to be able to detect that the other app creates motion
	if ("capability.motionSensor" in app1Capab) or ("capability.accelerationSensor" in app1Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (motion) detected between App1 and App2!\n")		
	#Water
	if ("capability.waterSensor" in app1Capab) and ("capability.valve" in app2Capab or 
			"capability.switch" in app2Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (water) detected between App1 and App2!\n")
	#Sound
	if ("capability.soundSensor" in app1Capab) and ("capability.musicPlayer" in app2Capab or 
			"capability.alarm" in app2Capab or "capability.speechSynthesis" in app2Capab):
		print ("\nWARNING: Potential PHYSICAL CONFLICT (sound) detected between App1 and App2!\n")

def ExtractEvents(extractedEvents):
	global eventList
	global eventVarMap
	global capabilityMap
	extractedEvents.write("while(true) {\n")
	extractedEvents.write("\tdef eventNumber = Verify.getInt(0,%d)\n" % (len(eventList) - 1))
	extractedEvents.write("\tswitch(eventNumber) {\n")
	for i in range(len(eventList)):
		extractedEvents.write("\t\tcase %d:\n" % i)
		if eventList[i] == "lock":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/lockLockedEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/lockUnlockedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "unlock":
			event = open("eventSimulator/unlockEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "contact.open":
			event = open("eventSimulator/contactOpenEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "contact.closed":
			event = open("eventSimulator/contactClosedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "nfcTouch":
			event = open("eventSimulator/nfcTouchEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "app": #Case for Touched event
			event = open("eventSimulator/appTouchEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "button":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/buttonPushedEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/buttonHeldEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "water":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/waterDryEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/waterWetEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "presence":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			#Write three events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,2)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			if capability == "capability.presenceSensor":
				event = open("eventSimulator/presencePresentEvent.groovy", "r")
			elif capability == "capability.beacon":
				event = open("eventSimulator/beaconPresentEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			if capability == "capability.presenceSensor":
				event = open("eventSimulator/presenceLeftEvent.groovy", "r")
			elif capability == "capability.beacon":
				event = open("eventSimulator/beaconLeftEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/presencePresencePresentEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "doorState":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/doorOpenEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/doorClosedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "motion":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/motionActiveEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/motionInactiveEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "smoke":
			#Write three events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,2)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/smokeClearEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/smokeDetectedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/smokeTestedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "carbonMonoxide":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			#Write three events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,2)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")			
			if capability == "capability.smokeDetector":
				event = open("eventSimulator/smokeCarbonMonoxideClearEvent.groovy", "r")
			elif capability == "capability.carbonMonoxideDetector":
				event = open("eventSimulator/carbonMonoxideClearEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			if capability == "capability.smokeDetector":
				event = open("eventSimulator/smokeCarbonMonoxideDetectedEvent.groovy", "r")
			elif capability == "capability.carbonMonoxideDetector":
				event = open("eventSimulator/carbonMonoxideDetectedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			if capability == "capability.smokeDetector":
				event = open("eventSimulator/smokeCarbonMonoxideTestedEvent.groovy", "r")
			elif capability == "capability.carbonMonoxideDetector":
				event = open("eventSimulator/carbonMonoxideTestedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "battery":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			if capability == "capability.smokeDetector":
				event = open("eventSimulator/smokeDetectorBatteryEvent.groovy", "r")
			elif capability == "capability.battery":
				event = open("eventSimulator/batteryBatteryEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "thermostatMode":
			#Write five events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,4)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/thermostatAutoModeEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/thermostatCoolModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 2) {\n")
			event = open("eventSimulator/thermostatEmergencyHeatModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 3) {\n")
			event = open("eventSimulator/thermostatHeatModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/thermostatOffModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "thermostatFanMode":
			#Write five events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,4)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/thermostatAutoFanModeEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/thermostatFanCirculateFanModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 2) {\n")
			event = open("eventSimulator/thermostatCirculateFanModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 3) {\n")
			event = open("eventSimulator/thermostatFanOnFanModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/thermostatOnFanModeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "thermostatOperatingState":
			#Write five events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,4)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/thermostatOperatingStateAutoEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/thermostatOperatingStateCoolEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 2) {\n")
			event = open("eventSimulator/thermostatOperatingStateOffEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 3) {\n")
			event = open("eventSimulator/thermostatOperatingStateEmergencyHeatEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/thermostatOperatingStateHeatEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "switch":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			if capability == "capability.switch":
				event = open("eventSimulator/switchOnEvent.groovy", "r")
			elif capability == "capability.switchLevel":
				event = open("eventSimulator/switchLevelOnEvent.groovy", "r")
			elif capability == "capability.relaySwitch":
				event = open("eventSimulator/relaySwitchOnEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			if capability == "capability.switch":
				event = open("eventSimulator/switchOffEvent.groovy", "r")
			elif capability == "capability.switchLevel":
				event = open("eventSimulator/switchLevelOffEvent.groovy", "r")
			elif capability == "capability.relaySwitch":
				event = open("eventSimulator/relaySwitchOffEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "location": #Case for Location event
			#Write three events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,2)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/locationHomeEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/locationAwayEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/locationNightEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "acceleration":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/accelerationActiveEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/accelerationInactiveEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "sleeping":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/sleepSleepingEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/sleepNotSleepingEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "goal":
			event = open("eventSimulator/stepGoalEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "steps":
			event = open("eventSimulator/stepStepsEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "color":
			event = open("eventSimulator/colorChangedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "hue":
			event = open("eventSimulator/hueChangedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "saturation":
			event = open("eventSimulator/saturationChangedEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "energy":
			event = open("eventSimulator/energyMeterEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "power":
			event = open("eventSimulator/powerMeterEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "illuminance":
			event = open("eventSimulator/illuminanceMeasurementEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "humidity":
			event = open("eventSimulator/humidityMeasurementEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "alarm":
			#Write four events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,3)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/alarmBothEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/alarmSirenEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 2) {\n")
			event = open("eventSimulator/alarmStrobeEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/alarmOffEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "contact":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			if capability == "capability.contactSensor":
				event = open("eventSimulator/contactDefaultClosedEvent.groovy", "r")
			elif capability == "capability.valve":
				event = open("eventSimulator/valveClosedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			if capability == "capability.contactSensor":
				event = open("eventSimulator/contactDefaultOpenEvent.groovy", "r")
			elif capability == "capability.valve":
				event = open("eventSimulator/valveOpenEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "status":
			#Write three events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,2)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/musicPlayerPlayingEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else if (event == 1) {\n")
			event = open("eventSimulator/musicPlayerStoppedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/musicPlayerPausedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "level":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			if capability == "capability.musicPlayer":
				event = open("eventSimulator/musicPlayerLevelEvent.groovy", "r")
			elif capability == "capability.switchLevel":
				event = open("eventSimulator/switchLevelEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "trackDescription":
			event = open("eventSimulator/musicPlayerTrackDescriptionEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "trackData":
			event = open("eventSimulator/musicPlayerTrackDataEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "mute":
			#Write two events subsequently
			extractedEvents.write("\t\t\tdef event = Verify.getInt(0,1)\n")
			extractedEvents.write("\t\t\tif (event == 0) {\n")
			event = open("eventSimulator/musicPlayerUnmutedEvent.groovy", "r")			
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t} else {\n")
			event = open("eventSimulator/musicPlayerMutedEvent.groovy", "r")
			for line in event:
				extractedEvents.write("\t\t" + line)
			event.close()
			extractedEvents.write("\t\t\t}\n")
		elif eventList[i] == "temperature":
			#Check which capability
			variable = eventVarMap[eventList[i]]
			capability = capabilityMap[variable]
			if capability == "capability.thermostat":
				event = open("eventSimulator/temperatureEvent.groovy", "r")
			elif capability == "capability.temperatureMeasurement":
				event = open("eventSimulator/temperatureMeasurementEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "heatingSetpoint":
			event = open("eventSimulator/heatingSetpointEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "coolingSetpoint":
			event = open("eventSimulator/coolingSetpointEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
		elif eventList[i] == "thermostatSetpoint":
			event = open("eventSimulator/thermostatSetpointEvent.groovy", "r")
			for line in event:
				extractedEvents.write(line)
			event.close()
			
		###TODO: Add more events later
		extractedEvents.write("\t\t\tbreak\n")
	extractedEvents.write("\t}\n")
	extractedEvents.write("}\n")
	
def CheckIfOnlyTouchEvents():
	#Check and throw an error if it is all touch events
	#This is called Direct-Direct interaction and we do not model-check for this case
	onlyTouchEvents = True
	for item in eventList:
		if item != "nfcTouch" and item != "app":
			onlyTouchEvents = False
	if onlyTouchEvents is True and app1Subscribe is True and app2Subscribe is True:
		# Write error log file
		extractError = open("appCreationError.log", "w+")
		extractError.write("Direct-Direct Interaction detected: we are skipping this pair...\n")
		extractError.close()
		raise Exception("\n\nDirect-Direct Interaction detected: we are skipping this pair...\n\n")


#Extract objects to call functions from App1
F1 = open("Extractor/App1/App1.groovy", "r")
extractedFunctionsApp1 = open("Extractor/App1/extractedFunctionsApp1.groovy", "w+")
ExtractFunctions(F1, "App1")
F1.close()

#Extract objects to call functions from App2
F2 = open("Extractor/App2/App2.groovy", "r")
extractedFunctionsApp2 = open("Extractor/App2/extractedFunctionsApp2.groovy", "w+")
ExtractFunctions(F2, "App2")
F2.close()

#Prepare eventSimulator file while parsing the App1 and App2 files
extractedEvents = open("eventSimulator/eventSimulator.groovy", "w+")
CheckIfOnlyTouchEvents()
ExtractEvents(extractedEvents)
extractedEvents.close()

#Save the extracted methods and app1 in a same file to extract information
extractorFile = open("Extractor/extractorFile.groovy", "w+")
Extractor = open("Extractor/Extractor.groovy", "r")
F1 = open("Extractor/App1/App1.groovy", "r")

extractorFile.write("////////////////////\n")
extractorFile.write("@Field App\n")
extractorFile.write("App = \"App1\"")
extractorFile.write("\n")
for line in Extractor:
	extractorFile.write(line)
extractorFile.write("\n\n")
for line in F1:
	extractorFile.write(line)
extractorFile.close()
Extractor.close()
F1.close()
#Run the file to extract the objects
os.system("groovy -classpath lib/jpf.jar Extractor/extractorFile.groovy")


#Save the extracted methods and app2 in a same file to extract information
extractorFile = open("Extractor/extractorFile.groovy", "w+")
Extractor = open("Extractor/Extractor.groovy", "r")
F2 = open("Extractor/App2/App2.groovy", "r")

extractorFile.write("////////////////////\n")
extractorFile.write("@Field App\n")
extractorFile.write("App = \"App2\"")
extractorFile.write("\n")
for line in Extractor:
	extractorFile.write(line)
extractorFile.write("\n\n")
for line in F2:
	extractorFile.write(line)
#Run the file to extract the objects
extractorFile.close()
Extractor.close()
F2.close()
os.system("groovy -classpath lib/jpf.jar Extractor/extractorFile.groovy")


