//Create a class for temperature measurement
package TemperatureMeasurement
import Timer.SimulatedTimer

//JPF's Verify API
import gov.nasa.jpf.vm.Verify

public class TemperatureMeasurements {
	private int deviceNumbers
	private List temperatureMeasurements
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private String id = "temperatureMeasurementID0"
	private String label = "temperatureMeasurement0"
	private String displayName = "temperatureMeasurement0"
	private int temperature = 50
	
	TemperatureMeasurements(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.temperatureMeasurements = []

		//def initTemp = Verify.getIntFromList(30, 50, 70)
		//this.temperature = initTemp
	
		temperatureMeasurements.add(new TemperatureMeasurement(id, label, displayName, this.temperature))
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		if (eventDataMap["value"] != temperatureMeasurements[0].temperature) {
			temperatureMeasurements[0].setValue(eventDataMap["value"])
			this.temperature = temperatureMeasurements[0].temperature
			sendEvent(eventDataMap)
		}
	}

	//Methods for closures
	def count(Closure Input) {
		temperatureMeasurements.count(Input)
	}
	def size() {
		temperatureMeasurements.size()
	}
	def each(Closure Input) {
		temperatureMeasurements.each(Input)
	}
	def find(Closure Input) {
		temperatureMeasurements.find(Input)
	}
	def collect(Closure Input) {
		temperatureMeasurements.collect(Input)
	}

	def getAt(int ix) {
		temperatureMeasurements[ix]
	}
}
